UIPackage
Menu

Framework

Change language

Boilerplate repo

Virtual List

virtual-listui

Generic windowed scroller. Renders only visible items plus a small overscan, with fixed or dynamic item sizes. Use for long lists where most rows are off-screen.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/virtual-list.json
Named registry:npx shadcn@latest add @uipkge-react/virtual-listInstalls to:components/ui/virtual-list/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
itemsT[]required
itemSize

Fixed pixel size, or a measurer called per item/index.

number | ((item: T, index: number) => number)required
heightnumber | stringrequired
overscannumberoptional
keyFieldkeyof T | stringoptional
direction'vertical' | 'horizontal'optional
classNamestringoptional
children

Render-prop for each row.

(item: T, index: number) => React.ReactNoderequired
onScroll(event: React.UIEvent<HTMLDivElement>) => voidoptional
onRangeChange(range: [number, number]) => voidoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

VirtualListHandle
interface VirtualListHandle {
  scrollToOffset: (px: number) => void
  scrollToIndex: (index: number, options?: { align?: 'start' | 'center' | 'end' }) => void
  getVisibleRange: () => [number, number]
}

npm dependencies

Files installed (2)

  • components/ui/virtual-list/virtual-list.tsx4.2 kB
    'use client'
    
    import * as React from 'react'
    import { useVirtualizer } from '@tanstack/react-virtual'
    import { cn } from '@/lib/utils'
    
    export interface VirtualListHandle {
      scrollToOffset: (px: number) => void
      scrollToIndex: (index: number, options?: { align?: 'start' | 'center' | 'end' }) => void
      getVisibleRange: () => [number, number]
    }
    
    export interface VirtualListProps<T> {
      items: T[]
      /** Fixed pixel size, or a measurer called per item/index. */
      itemSize: number | ((item: T, index: number) => number)
      height: number | string
      overscan?: number
      keyField?: keyof T | string
      direction?: 'vertical' | 'horizontal'
      className?: string
      /** Render-prop for each row. */
      children: (item: T, index: number) => React.ReactNode
      onScroll?: (event: React.UIEvent<HTMLDivElement>) => void
      onRangeChange?: (range: [number, number]) => void
    }
    
    function VirtualListInner<T extends Record<string, any>>(
      {
        items,
        itemSize,
        height,
        overscan = 3,
        keyField = 'id',
        direction = 'vertical',
        className,
        children,
        onScroll,
        onRangeChange,
      }: VirtualListProps<T>,
      ref: React.Ref<VirtualListHandle>,
    ) {
      const scrollRef = React.useRef<HTMLDivElement | null>(null)
      const isVertical = direction === 'vertical'
    
      const numericHeight = typeof height === 'number' ? height : Number.parseInt(String(height), 10) || 200
    
      const virtualizer = useVirtualizer({
        count: items.length,
        horizontal: !isVertical,
        getScrollElement: () => scrollRef.current,
        estimateSize: (index) => (typeof itemSize === 'function' ? itemSize(items[index]!, index) : itemSize),
        overscan,
        initialRect: { width: numericHeight, height: numericHeight },
        getItemKey: (index) => {
          const item = items[index]
          const k = item?.[keyField as keyof T]
          return (k ?? index) as string | number
        },
      })
    
      const virtualItems = virtualizer.getVirtualItems()
      const totalSize = virtualizer.getTotalSize()
    
      React.useEffect(() => {
        if (!onRangeChange || virtualItems.length === 0) return
        onRangeChange([virtualItems[0]!.index, virtualItems[virtualItems.length - 1]!.index + 1])
      }, [virtualItems, onRangeChange])
    
      React.useImperativeHandle(
        ref,
        () => ({
          scrollToOffset: (px) => virtualizer.scrollToOffset(px),
          scrollToIndex: (index, options) => virtualizer.scrollToIndex(index, { align: options?.align ?? 'start' }),
          getVisibleRange: () => {
            const v = virtualizer.getVirtualItems()
            if (v.length === 0) return [0, 0]
            return [v[0]!.index, v[v.length - 1]!.index + 1]
          },
        }),
        [virtualizer],
      )
    
      const h = typeof height === 'number' ? `${height}px` : height
      const containerStyle: React.CSSProperties = isVertical
        ? { height: h, overflowY: 'auto' }
        : { width: h, overflowX: 'auto' }
    
      const innerStyle: React.CSSProperties = isVertical
        ? { height: `${totalSize}px`, position: 'relative', width: '100%' }
        : { width: `${totalSize}px`, position: 'relative', height: '100%' }
    
      return (
        <div
          ref={scrollRef}
          data-uipkge=""
          data-slot="virtual-list"
          className={cn('w-full', className)}
          style={containerStyle}
          onScroll={onScroll}
        >
          <div style={innerStyle}>
            {virtualItems.map((virtualItem) => {
              const item = items[virtualItem.index]!
              const rowStyle: React.CSSProperties = isVertical
                ? {
                    position: 'absolute',
                    top: 0,
                    left: 0,
                    width: '100%',
                    height: `${virtualItem.size}px`,
                    transform: `translateY(${virtualItem.start}px)`,
                  }
                : {
                    position: 'absolute',
                    top: 0,
                    left: 0,
                    height: '100%',
                    width: `${virtualItem.size}px`,
                    transform: `translateX(${virtualItem.start}px)`,
                  }
              return (
                <div key={virtualItem.key} style={rowStyle}>
                  {children(item, virtualItem.index)}
                </div>
              )
            })}
          </div>
        </div>
      )
    }
    
    const VirtualList = React.forwardRef(VirtualListInner) as <T extends Record<string, any>>(
      props: VirtualListProps<T> & { ref?: React.Ref<VirtualListHandle> },
    ) => React.ReactElement
    
    export { VirtualList }
    
  • components/ui/virtual-list/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/react/virtual-list.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Virtual List

virtual-listui

Generic windowed scroller. Renders only visible items plus a small overscan, with fixed or dynamic item sizes. Use for long lists where most rows are off-screen.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/virtual-list.json
Named registry:npx shadcn-vue@latest add @uipkge/virtual-listInstalls to:app/components/ui/virtual-list/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
itemsT[]required
itemSizenumber | ((item: T, index: number)required

Files installed (2)

  • app/components/ui/virtual-list/VirtualList.vue5.3 kB
    <script setup lang="ts" generic="T extends Record<string, any>">
    import { computed, onBeforeUnmount, onMounted, ref, watch } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    
    const props = withDefaults(
      defineProps<{
        items: T[]
        itemSize: number | ((item: T, index: number) => number)
        height: number | string
        overscan?: number
        keyField?: string
        direction?: 'vertical' | 'horizontal'
        as?: string
        class?: HTMLAttributes['class']
      }>(),
      {
        overscan: 3,
        keyField: 'id',
        direction: 'vertical',
        as: 'div',
      },
    )
    
    const emits = defineEmits<{
      (e: 'scroll', event: Event): void
      (e: 'range-change', range: [number, number]): void
    }>()
    
    const scrollEl = ref<HTMLElement | null>(null)
    const scrollOffset = ref(0)
    const viewportSize = ref(
      typeof props.height === 'number' ? props.height : Number.parseInt(String(props.height), 10) || 0,
    )
    
    const isVertical = computed(() => props.direction === 'vertical')
    
    const offsets = computed<number[]>(() => {
      const out: number[] = [0]
      for (let i = 0; i < props.items.length; i++) {
        const s = typeof props.itemSize === 'function' ? props.itemSize(props.items[i]!, i) : props.itemSize
        out.push(out[i]! + s)
      }
      return out
    })
    
    const totalSize = computed(() => offsets.value[props.items.length] ?? 0)
    
    function findIndex(target: number): number {
      const o = offsets.value
      let lo = 0
      let hi = o.length - 1
      while (lo < hi) {
        const mid = (lo + hi + 1) >> 1
        if (o[mid]! <= target) lo = mid
        else hi = mid - 1
      }
      return lo
    }
    
    const range = computed<[number, number]>(() => {
      if (!props.items.length || viewportSize.value === 0) return [0, 0]
      const start = Math.max(0, findIndex(scrollOffset.value) - props.overscan)
      const end = Math.min(props.items.length, findIndex(scrollOffset.value + viewportSize.value) + 1 + props.overscan)
      return [start, end]
    })
    
    const visible = computed(() => props.items.slice(range.value[0], range.value[1]))
    const offsetStart = computed(() => offsets.value[range.value[0]] ?? 0)
    
    watch(range, (r) => emits('range-change', r))
    
    function onScroll(e: Event) {
      const el = e.target as HTMLElement
      scrollOffset.value = isVertical.value ? el.scrollTop : el.scrollLeft
      emits('scroll', e)
    }
    
    function measure() {
      if (!scrollEl.value) return
      const measured = isVertical.value ? scrollEl.value.clientHeight : scrollEl.value.clientWidth
      const fallback = typeof props.height === 'number' ? props.height : Number.parseInt(String(props.height), 10) || 0
      viewportSize.value = measured || fallback
    }
    
    let resizeObserver: ResizeObserver | null = null
    
    onMounted(() => {
      measure()
      if (typeof ResizeObserver !== 'undefined' && scrollEl.value) {
        resizeObserver = new ResizeObserver(measure)
        resizeObserver.observe(scrollEl.value)
      }
    })
    
    onBeforeUnmount(() => {
      resizeObserver?.disconnect()
      resizeObserver = null
    })
    
    watch(() => props.height, measure, { flush: 'post' })
    
    function sizeOf(item: T, i: number) {
      return typeof props.itemSize === 'function' ? props.itemSize(item, i) : props.itemSize
    }
    
    function getKey(item: T, fallback: number): string | number {
      const k = item[props.keyField]
      return k ?? fallback
    }
    
    function scrollToOffset(px: number) {
      if (!scrollEl.value) return
      if (isVertical.value) scrollEl.value.scrollTop = px
      else scrollEl.value.scrollLeft = px
    }
    
    function scrollToIndex(i: number, options: { align?: 'start' | 'center' | 'end' } = {}) {
      const align = options.align ?? 'start'
      const start = offsets.value[i] ?? 0
      const size = (offsets.value[i + 1] ?? start) - start
      let target = start
      if (align === 'center') target = start - viewportSize.value / 2 + size / 2
      else if (align === 'end') target = start - viewportSize.value + size
      scrollToOffset(Math.max(0, target))
    }
    
    function getVisibleRange(): [number, number] {
      return range.value
    }
    
    defineExpose({ scrollToOffset, scrollToIndex, getVisibleRange })
    
    const containerStyle = computed((): Record<string, string> => {
      const h = typeof props.height === 'number' ? `${props.height}px` : props.height
      return isVertical.value ? { height: h, overflowY: 'auto' } : { width: h, overflowX: 'auto' }
    })
    
    const innerStyle = computed(
      (): Record<string, string> =>
        isVertical.value
          ? { height: `${totalSize.value}px`, position: 'relative', width: '100%' }
          : { width: `${totalSize.value}px`, position: 'relative', height: '100%' },
    )
    
    const offsetStyle = computed(
      (): Record<string, string> =>
        isVertical.value
          ? { transform: `translateY(${offsetStart.value}px)` }
          : { transform: `translateX(${offsetStart.value}px)`, height: '100%', display: 'flex' },
    )
    </script>
    
    <template>
      <component
        :is="as"
        ref="scrollEl"
        data-uipkge
        data-slot="virtual-list"
        :class="cn('w-full', props.class)"
        :style="containerStyle"
        @scroll.passive="onScroll"
      >
        <div :style="innerStyle">
          <div :style="offsetStyle">
            <div
              v-for="(item, i) in visible"
              :key="getKey(item, range[0] + i)"
              :style="
                isVertical
                  ? { height: sizeOf(item, range[0] + i) + 'px' }
                  : { width: sizeOf(item, range[0] + i) + 'px', flexShrink: 0 }
              "
            >
              <slot :item="item" :index="range[0] + i" />
            </div>
          </div>
        </div>
      </component>
    </template>
    
  • app/components/ui/virtual-list/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/vue/virtual-list.json